#include "gtest/gtest.h"
#include "../Trie.h"
#include <iostream>
#include <string>
#include <vector>
using namespace std;

class Testing : public ::testing::Test {

protected:
    Testing() {}
    virtual ~Testing() {
    }

    virtual void SetUp() {}
    
    virtual void TearDown() {
	cout << endl << ":::END" << endl;
    }
};
    

TEST_F(Testing, CopyConstructor) {
    cout << ":::NAME test copy constructor" << endl;
    cout << ":::MAX_SCORE 9" << endl;
    cout << ":::SCORE 9" << endl;
    cout << ":::VISIBILITY visible" << endl;
    cout << "\nTesting with a Trie with cat, cast, dog added." << endl;
    Trie searchDict;
    searchDict.addAWord("cat");
    searchDict.addAWord("cast");
    searchDict.addAWord("dog");

    cout << "\nCopying the Trie." << endl;
    Trie other(searchDict);
    cout << "Add 'mouse' to original" << endl;
    searchDict.addAWord("mouse");
    cout << "Testing if 'mouse' is also in copy from shared Trie nodes" << endl;
    EXPECT_FALSE(other.isAWord("mouse")) << ":::SCORE 0";
    EXPECT_TRUE(searchDict.isAWord("mouse")) << ":::SCORE 0";
}

TEST_F(Testing, AssignmentOperator) {
    cout << ":::NAME test assignment operator" << endl;
    cout << ":::MAX_SCORE 9" << endl;
    cout << ":::SCORE 9" << endl;
    cout << ":::VISIBILITY visible" << endl;
    cout << "\nTesting with a Trie with cat, cast, dog added." << endl;
    Trie searchDict;
    searchDict.addAWord("cat");
    searchDict.addAWord("cast");
    searchDict.addAWord("dog");

    cout << "\nAssigning  the Trie after adding 'any' to the other Trie." << endl;
    Trie other;
    other.addAWord("any");
    other = searchDict;
    cout << "Add 'mouse' to original" << endl;
    searchDict.addAWord("mouse");
    cout << "Testing if 'mouse' is also in copy from shared Trie nodes" << endl;
    EXPECT_FALSE(other.isAWord("mouse")) << ":::SCORE 0";
    EXPECT_TRUE(searchDict.isAWord("mouse")) << ":::SCORE 0";
    cout << "checking if 'any' survived being assigned over" << endl;
    EXPECT_FALSE(other.isAWord("any")) << ":::SCORE 0";
}



int main(int argc, char **argv) {
  testing::InitGoogleTest(&argc, argv);
  RUN_ALL_TESTS();
  return 0;
}
